﻿using System;
using System.Collections.Generic;
using System.Text;
using stepnc_plugin;

namespace SamplePlugin
{
    public class SamplePlugin : ICNCPlugin
    {
	long blocknum;

	double [,] points = new double [4,2] {{-3, -3}, {3, -3}, {3, 3}, {-3, 3}};


	public bool LoadCNC()
	{
	    // do any setup to connect to the machine
	    blocknum = 0;
	    return true;
	}

	public bool IsConnected()
	{
	    return true;
	}

	public bool IsSTEPNCPosition()
	{
	    return false;  // return true if we actually process gcodes from the setcurrentprogram
	}

	public void UnloadCNC()
	{
	    // disconnect from the machine and do any cleanup
	}

	public bool GetProgramPosition(out long block, out double x, out double y, out double z)
	{
	    // Return the current block as the sequence number of
	    // blocks counted from the start of the file.   Here we
	    // just fake it by incrementing a counter.

	    block =  blocknum++;
	    x = points[block % 4, 0];// current x coordiate  
	    y = points[block % 4, 1];// current y coordiate  
	    z = 3.0;   // current z coordiate  
	    return true;
	}

	public UnitType GetProgramPositionUnit()
	{
	    // What unit system are the X/Y/Z values in?
	    //return UnitType.UnitMM;
	    return UnitType.UnitInch;
	}
	
	public BlockNumberType GetProgramBlockType()
	{
	    return BlockNumberType.BlockCount;
	}


	public string GetMachineDesc()
	{
	    return "Fake CNC to Test Plugin Code";
	}

	public void SetCurrentProgram(string path)
	{
	    // do something
	}




    }
}
