﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace PlugTester
{
    public partial class TestForm : Form
    {
	stepnc_plugin.ICNCPlugin plug;
	
	public TestForm()
	{
	    InitializeComponent();
	}

	private void CleanupForm(object sender, FormClosingEventArgs e)
	{
	    polltime.Enabled = false;
	    plug.UnloadCNC();
	}

	private void LoadForm(object sender, EventArgs e)
	{
	    //plug = new SamplePlugin.SamplePlugin();
	    plug = new SamplePlugin.MTConnectPlugin();
	    //plug = new SamplePlugin.TextPlugin();
	    if (plug.LoadCNC())
		txtStatus.Text = "Status: Connected";
	    else
		txtStatus.Text = "Status: Not Connected";

	    txtDesc.Text = "Machine: " + plug.GetMachineDesc();
	    polltime.Enabled = false;
	}


	private void btnProgram_Click(object sender, EventArgs e)
	{
	    OpenFileDialog dlg = new OpenFileDialog();
	    dlg.Title = "Select Program File";
	    if (dlg.ShowDialog() == System.Windows.Forms.DialogResult.OK)
		plug.SetCurrentProgram(dlg.FileName);
	}

	private void btnPoll_Click(object sender, EventArgs e)
	{
	    polltime.Enabled = !polltime.Enabled;
	    btnPoll.Text = polltime.Enabled ? "Stop Polling" : "Start Polling";
	}

	private void UpdatePosition(object sender, EventArgs e)
	{
	    string unitdesc = "Unknown";
	    switch (plug.GetProgramPositionUnit())
	    {
		case stepnc_plugin.UnitType.UnitInch:
		    unitdesc = "in";
		    break;

		case stepnc_plugin.UnitType.UnitMM:
		    unitdesc = "mm";
		    break;
	    }

	    long blk;
	    double x, y, z;
	    plug.GetProgramPosition(out blk, out x, out y, out z);

	    blockval.Text = blk.ToString();
	    xval.Text = String.Format("{0} {1}", x, unitdesc);
	    yval.Text = String.Format("{0} {1}", y, unitdesc);
	    zval.Text = String.Format("{0} {1}", z, unitdesc);
	}

	
	
    }
}
